import * as React from "react";
export function useAnimationFrame(update, pause = false, deps = []) {
    const latestAnimationFrame = React.useRef(null);
    React.useEffect(() => {
        if (typeof pause === "function" ? pause() : pause) {
            return;
        }
        latestAnimationFrame.current = requestAnimationFrame(() => {
            update();
        });
        return () => {
            if (latestAnimationFrame.current) {
                cancelAnimationFrame(latestAnimationFrame.current);
            }
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [update, pause, ...deps]);
}
//# sourceMappingURL=useAnimationFrame.js.map