import * as React from "react";
const setEventListeners = (events, fn, elem, set) => {
    events.forEach((event) => {
        (set === "add" ? elem.addEventListener : elem.removeEventListener)(event, fn, {
            capture: true,
            passive: true,
        });
    });
};
export function useAttachEventListeners(elem, events, cb) {
    React.useEffect(() => {
        if (!elem) {
            return;
        }
        setEventListeners(events, cb, elem, "add");
        return () => {
            setEventListeners(events, cb, elem, "remove");
        };
    }, [cb, elem, events]);
}
//# sourceMappingURL=useAttachEventListeners.js.map