import * as React from "react";
import { useAnimationFrame } from "./useAnimationFrame";
import { getFitOffsets } from "./positionerUtils";
const DEFAULT_POSITION = { top: 0, left: 0 };
export function useFitInViewport(elemRef, targetPos, viewportOffset = 0) {
    const [style, setStyle] = React.useState(targetPos);
    React.useEffect(() => {
        setStyle(targetPos);
    }, [targetPos]);
    useAnimationFrame(() => {
        if (!elemRef.current) {
            return;
        }
        const { x, y } = getFitOffsets(viewportOffset)(elemRef.current.getBoundingClientRect());
        setStyle((prevStyle) => {
            const nextStyle = {
                top: (prevStyle || DEFAULT_POSITION).top + y,
                left: (prevStyle || DEFAULT_POSITION).left + x,
            };
            return nextStyle;
        });
    }, () => !elemRef.current, [style]);
    return { style };
}
//# sourceMappingURL=useFitInViewport.js.map